;Program: Notepad 82 ASM
;Name: Adam Milecki (TideGear@aol.com)
;Date: 6/8/1999

#include "ti82.h"
#include "crash82.inc"

.org START_ADDR      
.db "Notepad",0     

 ROM_CALL(CLEARLCD)      

enterText:           
 
 ld hl,text      
 ld (hl),'_'
 ld c,0
    
_txtEnter:              
 push hl
 ld hl,0
 ld (CURSOR_POS),hl
 ld hl,text
 ROM_CALL(D_ZT_STR)

_keyPress:
 push bc
 call GET_KEY
 pop bc
 pop hl
 inc hl
 ld (hl),0
 dec hl
 cp G_PERIOD
 jp z,_charPeriod
 cp G_MATH
 jp z,_charA
 cp G_MATRIX
 jp z,_charB
 cp G_PRGM
 jp z,_charC
 cp G_INVE
 jp z,_charD
 cp G_SIN
 jp z,_charE
 cp G_COS
 jp z,_charF
 cp G_TAN
 jp z,_charG
 cp G_CARROT
 jp z,_charH
 cp G_SQR
 jp z,_charI
 cp G_COMMA
 jp z,_charJ
 cp G_PARENL
 jp z,_charK
 cp G_PARENR
 jp z,_charL
 cp G_DIV
 jp z,_charM
 cp G_LOG
 jp z,_charN
 cp G_7
 jp z,_charO
 cp G_8
 jp z,_charP
 cp G_9
 jp z,_charQ
 cp G_TIMES
 jp z,_charR
 cp G_LN
 jp z,_charS 
 cp G_4
 jp z,_charT
 cp G_5
 jp z,_charU
 cp G_6
 jp z,_charV
 cp G_MINUS
 jp z,_charW
 cp G_STO
 jp z,_charX
 cp G_1
 jp z,_charY
 cp G_2
 jp z,_charZ
 cp G_NEG
 jp z,_charMinus
 cp G_0
 jp z,_charSpace
 cp G_DEL
 jp z,_backspace
 cp G_ENTER
 jp z,_Quit
 cp G_ALPHA
 jp z,_NumlockTE
 jp _txtEnter

_Numlock
 push bc
 call GET_KEY
 pop bc
 pop hl
 inc hl
 ld (hl),0
 dec hl
 cp G_PERIOD
 jp z,_charPeriod
 cp G_MATH
 jp z,_charA
 cp G_MATRIX
 jp z,_charB
 cp G_PRGM
 jp z,_charC
 cp G_INVE
 jp z,_charD
 cp G_SIN
 jp z,_charE
 cp G_COS
 jp z,_charF
 cp G_TAN
 jp z,_charG
 cp G_CARROT
 jp z,_charH
 cp G_SQR
 jp z,_charI
 cp G_COMMA
 jp z,_charJ
 cp G_PARENL
 jp z,_charK
 cp G_PARENR
 jp z,_charL
 cp G_DIV
 jp z,_charM
 cp G_LOG
 jp z,_charN
 cp G_7
 jp z,_char7
 cp G_8
 jp z,_char8
 cp G_9
 jp z,_char9
 cp G_TIMES
 jp z,_charR
 cp G_LN
 jp z,_charS 
 cp G_4
 jp z,_char4
 cp G_5
 jp z,_char5
 cp G_6
 jp z,_char6
 cp G_MINUS
 jp z,_charW
 cp G_STO
 jp z,_charX
 cp G_1
 jp z,_char1
 cp G_2
 jp z,_char2
 cp G_3
 jp z,_char3
 cp G_0
 jp z,_char0
 cp G_NEG
 jp z,_charMinus
 cp G_0
 jp z,_charSpace
 cp G_DEL
 jp z,_backspace
 cp G_ENTER
 jp z,_Quit
 cp G_ALPHA
 jp z,_txtEnter
 jp z,_NumlockTE

_NumlockTE:
 push hl
 ld hl,0
 ld (CURSOR_POS),hl
 ld hl,text
 ROM_CALL(D_ZT_STR)
 jp _Numlock

_Quit:
 ld a,c
 inc hl
 inc c
 ld (hl),' '
 ret 

_charMinus:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'-'
 jp _txtEnter

_charSpace:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),' '
 jp _txtEnter

_char0
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'0'
 jp _NumlockTE

_char1
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'1'
 jp _NumlockTE

_char2
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'2'
 jp _NumlockTE

_char3
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'3'
 jp _NumlockTE

_char4
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'4'
 jp _NumlockTE

_char5
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'5'
 jp _NumlockTE

_char6
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'6'
 jp _NumlockTE

_char7
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'7'
 jp _NumlockTE

_char8
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'8'
 jp _NumlockTE

_char9
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'9'
 jp _NumlockTE

_charPeriod:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'.'
 jp _txtEnter

_charA:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'A'
 jp _txtEnter

_charB:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'B'
 jp _txtEnter

_charC:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'C'
 jp _txtEnter

_charD:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'D'
 jp _txtEnter

_charE:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'E'
 jp _txtEnter

_charF:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'F'
 jp _txtEnter

_charG:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'G'
 jp _txtEnter

_charH:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'H'
 jp _txtEnter

_charI:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'I'
 jp _txtEnter

_charJ:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'J'
 jp _txtEnter

_charK:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'K'
 jp _txtEnter

_charL:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'L'
 jp _txtEnter

_charM:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'M'
 jp _txtEnter

_charN:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'N'
 jp _txtEnter

_charO:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'O'
 jp _txtEnter

_charP:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'P'
 jp _txtEnter

_charQ:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'Q'
 jp _txtEnter

_charR:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'R'
 jp _txtEnter

_charS:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'S'
 jp _txtEnter

_charT:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'T'
 jp _txtEnter

_charU:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'U'
 jp _txtEnter

_charV:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'V'
 jp _txtEnter

_charW:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'W'
 jp _txtEnter

_charY:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'Y'
 jp _txtEnter

_charX:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'X'
 jp _txtEnter

_charZ:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'Z'
 jp _txtEnter

_backspace:
 ld a,c
 or a
 jp z,_noBckspce
 ld (hl),' '
 dec hl
 dec c
_noBckspce:
 jp _txtEnter

_saveLetter:
 ld a,c
 cp 124
 jp z,_noSaveLtr
 inc hl
 inc c
 ld (hl),'A'
_noSaveLtr:
 jp _txtEnter

text:           ;current user's text (124+1)
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

 .end



